import { css } from "@linaria/core";
import { number, string } from "vue-types";
import { useCompData } from ".";
import { useEditor } from "../../../../..";
import { Image, Text } from "../../../basicUI";
import { createUIComp } from "../../../defines/createUIComp";
import { WidthEditlayer } from "../../../basicUI/utils";
import { View } from "../../../basicUI/View";

export const Component = createUIComp({
  props: {
    compId: string().isRequired,
  },
  setup(props) {
    const { store  , helper} = useEditor();
    const { children } = useCompData(props.compId);

    const designToNaturalSize = helper.designToNaturalSize;
    function fixedSize(id:string, w:number, h:number)
    { 
        const item1Comp = store.compMap[id]
        if ( !item1Comp ) return;

        if (item1Comp.layout.size) {
          const isDefault = item1Comp.layout.size[0] == 750 && item1Comp.layout.size[1] == 400
          if (isDefault) {
            item1Comp.layout.size[0] = w;
            item1Comp.layout.size[1] = h;
          }
        }
    }
    
    fixedSize(children.item1, 191, 191);
    fixedSize(children.item2, 191, 191);
    fixedSize(children.item3, 191, 191);


    return () => (
      <div class="absolute">
          <div class={style}>
            <Image.Component compId={children.bgImg} />
          </div>

          <Image.Component
                class="rounded-1/2 overflow-hidden top-0"
                editlayer = {false}
                compId={children.item1}
              />

            <Image.Component
                      class="rounded-1/2 overflow-hidden top-0"
                      compId={children.item2}
                      editlayer = {false}
                    />   

          <Image.Component
                  class="rounded-1/2 overflow-hidden top-0"
                  compId={children.item3}
                  editlayer = {false}
              />

        <Text.Component compId={children.text1} class={"top-0"} />
        
        <Text.Component compId={children.text2} class={"top-0"} />
      </div>
    );
  },
});

const style = css`
  background: gray;
  clip-path: polygon(0 0, 100% 0, 100% 57%, 0 100%);
`;
